SystemOrganization addCategory: #'LispKit-Reader-Base'!


Object subclass: #LKNonReadableObject
	instanceVariableNames: 'printedRepresentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit-Reader-Base'!

LKNonReadableObject class
	instanceVariableNames: ''!

Object subclass: #LKIOPort
	instanceVariableNames: 'inStream outStream status'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit-Reader-Base'!

Object subclass: #LKReader
	instanceVariableNames: 'lisp labels'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit-Reader-Base'!

LKReader class
	instanceVariableNames: 'CharacterNames Macros SharpMacros SyntacticTypes'!

WriteStream subclass: #LKToken
	instanceVariableNames: 'couldBeFraction couldBeExponent couldBeNumber base number dot sign nindex n1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit-Reader-Base'!

LKToken class
	instanceVariableNames: ''!

LKIOPort class
	instanceVariableNames: ''!


!LKIOPort commentStamp: 'spfa 10/20/2006 13:03' prior: 0!
Interface presenting smalltalk streams as Lisp streams!
]style[(54)!

!LKReader commentStamp: 'spfa 10/11/2006 11:49' prior: 0!
a reader for textual Lisp code/data

based on Common Lisp the Language, 2nd edition, chapter 22.1!
]style[(97)!

!LKIOPort methodsFor: 'proxy' stamp: 'spfa 11/18/2009 18:10'!
atEnd

	^ self stream atEnd! !

!LKReader methodsFor: 'macros' stamp: 'spfa 11/18/2009 18:10'!
backquote: aStream

	^ #quasiquote inCons addLast: (self read: aStream)! !

!LKToken methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
base: aNumber

	base _ aNumber! !

!LKReader class methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
characterNames 

	^ CharacterNames ! !

!LKIOPort methodsFor: '-- hacks --' stamp: 'spfa 11/18/2009 18:10'!
clear
	"Clear all characters and redisplay the view"
	self changed: #clearText.
"	self stream reset"! !

!LKIOPort methodsFor: 'proxy' stamp: 'spfa 11/18/2009 18:10'!
close

	self stream close
! !

!LKReader methodsFor: 'macros' stamp: 'spfa 11/18/2009 18:10'!
closeList: aStream

	^ self closeListMarker! !

!LKReader methodsFor: 'macros' stamp: 'spfa 11/18/2009 18:10'!
closeListMarker

	^ #'------(end------'! !

!LKReader methodsFor: 'macros' stamp: 'spfa 11/18/2009 18:10'!
comment: aStream

	| char |

	[char == Character lf  
		or: [char == Character cr] 
		or: [aStream atEnd]]
	whileFalse:
		[char _ aStream next].

	^ nil! !

!LKToken methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
digit: aCharacter

	| value |
	value _ aCharacter asciiValue.
	(value >= 48 and: [value <= (48 + base - 1)]) ifTrue: [^ value - 48].

	base > 10 ifFalse: [^ nil].

	(value >= 65 and: [value <= (65 + base - 11)]) ifTrue: [^ value - 55].
	(value >= 97 and: [value <= (97 + base - 11)]) ifTrue: [^ value - 87].

	^ nil! !

!LKReader methodsFor: 'macros' stamp: 'spfa 11/18/2009 18:10'!
emptyListMarker

	^ #'------()------'! !

!LKIOPort methodsFor: '-- hacks --' stamp: 'spfa 11/18/2009 18:10'!
endEntry
	"Display all the characters since the last endEntry, and reset the stream"

	self changed: #endEntry.
"	self dependents ifNotEmpty: [self reset]."
	! !

!LKIOPort class methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
eof

	^ #'<eof>'! !

!LKReader class methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
for: aLisp

	^ self new lisp: aLisp! !

!LKIOPort class methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
forInput

	^ self input: (ReadWriteStream on: Text new)
! !

!LKIOPort class methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
forOutput

	^ self output: (WriteStream on: Text new)
! !

!LKIOPort methodsFor: '-- hacks --' stamp: 'spfa 11/18/2009 18:10'!
force
	"Force all pending output to be processed"
	self changed: #force.
"	self stream reset"! !

!LKReader methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
foundToken: aStream

	"tells weither a token can be read from aStream"

	[aStream atEnd not 
		and: [(self class syntacticTypes at: aStream peek asciiValue) == #whiteSpace]] 
	whileTrue: [aStream next].

	^ aStream atEnd not! !

!LKToken methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
getN1

	n1 _ number * sign. 
	nindex _ 0. 
	dot _ nil. 
	sign _ 1.
	number _ nil! !

!LKIOPort methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
inStream

	^ inStream ! !

!LKIOPort methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
inStream: aStream

	inStream _ aStream! !

!LKReader class methodsFor: 'as yet unclassified' stamp: 'spfa 9/23/2010 11:45'!
initialize
	
	"LKReader initialize "
	"see Common Lisp the Language, 2nd edition, section 22.1.1"

	SyntacticTypes _ Array new: 256 withAll: #constituent. "default"
	SyntacticTypes 
		atAll: #(9 10 12 13 32 160) put: #whiteSpace. "tab lf ff cr space +PLT compatibility"

	SyntacticTypes 
		atAll: (#($" $; $' $( $) $, $`) collect: [:c | c asciiValue]) 
		put: #terminatingMacro.

	SyntacticTypes at: $\ asciiValue put: #singleEscape.
	SyntacticTypes at: $| asciiValue put: #multipleEscape.
	SyntacticTypes at: $# asciiValue put: #nonTerminatingMacro.
		
	Macros _ Dictionary new.
	{
		$# -> #sharpMacro:.
		$( -> #openList:.
		$) -> #closeList:.
		$' -> #quote:.
		$; -> #comment:.
		$" -> #string:.
		$` -> #backquote:.
		$, -> #unquote:.	
	}
	do: [:assoc | Macros add: assoc].

	SharpMacros _ Dictionary new.
	{
		$# -> #sharpLabelReference:n:.
		$( -> #sharpVector:n:.
		$' -> #sharpFunction:n:.
		$* -> #sharpBitVector:n:.
		$= -> #sharpLabel:n:.
		$\ -> #sharpCharacter:n:.
		$, -> #sharpLoadTimeEvaluation:n:.
		$| -> #sharpBalancedComment:n:.
		$- -> #sharpReadTimeUnless:n:.
		$+ -> #sharpReadTimeWhen:n:.
		$. -> #sharpReadTimeEvaluation:n:.
		$: -> #sharpUninternedSymbol:n:.
		$a -> #sharpArray:n:.
		$A -> #sharpArray:n:.
		$b -> #sharpBinaryRational:n:.
		$B -> #sharpBinaryRational:n:.
		$c -> #sharpComplexNumber:n:.
		$C -> #sharpComplexNumber:n:.
		$o -> #sharpOctalRational:n:.
		$O -> #sharpOctalRational:n:.
		$p -> #sharpPathName:n:.
		$P -> #sharpPathName:n:.
		$r -> #sharpRadixNRational:n:.
		$R -> #sharpRadixNRational:n:.
		$s -> #sharpStructure:n:.
		$S -> #sharpStructure:n:.
		$x -> #sharpHexaRational:n:.
		$X -> #sharpHexaRational:n:.
		$; -> #sharpComment:n:.
		$< -> #sharpNonReadable:n:.
		"Specific to Smalltalk"
		$_ -> #sharpMethod:n:
	}
	do: [:assoc | SharpMacros add: assoc].

	CharacterNames _ Dictionary new.
	{
		'newline' -> Character lf.
		'tab' -> Character cr.
		'linefeed' -> Character linefeed.
		'space' -> Character space.			
		'backspace' -> Character backspace.			
		'escape' -> Character escape.			
		'return' -> Character cr.			
		'rubout' -> Character delete.	
	}
	do: [:assoc | CharacterNames add: assoc].

	"self initialize"! !

!LKToken methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
initialize

	couldBeNumber _ true.
	couldBeFraction _ couldBeExponent _ true.
	base _ 10.
	number _ nil.
	dot _ n1 _ nil.
	sign _ 1.
	nindex _ 0.

! !

!LKIOPort class methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
input: aStream

	aStream ifNil: [self error: 'no stream specified'].

	^ self new 
		status: #in;
		inStream: aStream! !

!LKIOPort class methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
input: aStream output: bStream

	^ self new 
		status: #bi;
		outStream: aStream;
		inStream: aStream! !

!LKIOPort methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
isInput

	^ status == #in! !

!LKIOPort methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
isLKIOPort

	^ true! !

!LKIOPort methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
isOutput

	^ status == #out! !

!LKIOPort methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
isTwoWay

	^ status == #bi! !

!LKReader methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
labels

	^ labels ifNil: [labels _ Dictionary new]! !

!LKReader methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
lisp

	^ lisp ! !

!LKReader methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
lisp: aLisp

	lisp _ aLisp! !

!LKReader class methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
macros

	^ Macros! !

!LKToken methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
nextCharacter: aCharacter

	nindex _ nindex + 1.

	nindex = 1 ifTrue: 
	[
		aCharacter == $- 
			ifTrue: [sign _ -1]
			ifFalse: [
				((self digit: aCharacter) notNil 
					or: [aCharacter == $+] or: [aCharacter == $.])
				ifFalse: [couldBeNumber _ false]].
	].
		
	couldBeNumber ifFalse: [^ self].

	dot ifNotNil: [dot _ dot / 10].
	aCharacter == $. ifTrue: [	
		base = 10 ifFalse: [couldBeNumber _ false].
		couldBeFraction _ false.
		n1 ifNotNil: [couldBeExponent _ false].
		dot ifNotNil: [couldBeNumber _ false] ifNil: [dot _ 1].
	]
	ifFalse: [
		(couldBeExponent
			and: [n1 isNil] 
			and: [aCharacter == $e or: [aCharacter == $E]])
		ifTrue: [self getN1. couldBeFraction _ false]
		ifFalse: [
			(couldBeFraction
				and: [n1 isNil] 
				and: [aCharacter == $/])
			ifTrue: [self getN1. couldBeExponent _ false]
			ifFalse:
			[  | d |
				(d _ self digit: aCharacter) notNil 
				ifFalse: [
					(((aCharacter == $+)	or: [aCharacter == $-])
						and: [nindex = 1])
					ifFalse: [couldBeNumber _ false]
					ifTrue: [n1 ifNotNil: [couldBeFraction _ false]]]
				ifTrue: [
					number ifNil: [number _ 0].
					dot ifNil: [number _ (base * number) + d]
					ifNotNil: [number _ number asFloat + (d * dot)]]]]]

	! !

!LKToken methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
nextPut: aCharacter

	super nextPut: aCharacter.
	self nextCharacter: aCharacter! !

!LKToken methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
nextPutAll: aCollection 
	"Append the elements of aCollection to the sequence of objects accessible 
	by the receiver. Answer aCollection."

	aCollection do: [:v | self nextPut: v].
	^aCollection! !

!LKReader methodsFor: 'macros' stamp: 'spfa 4/18/2011 09:49'!
openList: aStream

	| list item lastCell |

	[item == self closeListMarker] whileFalse:
	[
		aStream atEnd ifTrue: [self error: 'open list'].
		item == #'.'
			ifTrue: "dotted pair notation" 
			[
				lastCell _ (self read: aStream).
				"handle special case: [. , -> ,@] 
				for example`(a b . ,c) becomes `(a b ,@c)"
				(lastCell isConsCell and: [lastCell car == #unquote])
					ifTrue: [
								list _ ((lastCell car: #'unquote-splicing') inCons cdr: list).
								lastCell _ nil
								].
				"the form `(... . @, ...) is not allowed"
				(lastCell isConsCell and: [lastCell car == #'unquote-splicing'])
					ifTrue: [self error: 'inappropriate context for unquote-splicing'].
			]
			ifFalse: [list _ (item inCons cdr: list)].
		item _ self read: aStream.
	].

	(list ifNil: [^ self emptyListMarker]) cells do: [:cell |
		cell setcdr: lastCell.
		lastCell _ cell].

	^ lastCell cdr ifNil: [self emptyListMarker]! !

!LKIOPort methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
outStream

	^ outStream ! !

!LKIOPort methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
outStream: aStream

	outStream _ aStream! !

!LKIOPort class methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
output: aStream

	aStream ifNil: [self error: 'no stream specified'].

	^ self new 
		status: #out;
		outStream: aStream! !

!LKToken class methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
parse: aString

	^ self parse: aString base: 10
	! !

!LKToken class methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
parse: aString base: aNumber

	| tok |
	tok _ self void.
	tok base: aNumber.
	tok nextPutAll: aString.
	^ tok parsed
	! !

!LKToken methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
parsed

	(couldBeNumber not or: [number isNil]) ifTrue: [^ self contents asSymbol].

	n1 ifNotNil: 
	[
		(couldBeFraction and: [number isZero not]) ifTrue: [^ n1/number].
		couldBeExponent ifTrue: [^ n1 asFloat * (10 raisedTo: (number * sign))].
		^ self contents asSymbol
	].

	^ number * sign! !

!LKNonReadableObject methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:10'!
printOn: aStream

	self printOn: aStream forLisp: nil
	! !

!LKNonReadableObject methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:10'!
printOn: aStream forLisp: aLisp

	aStream nextPutAll: '#<'; nextPutAll: printedRepresentation; nextPut: $>
	! !

!LKNonReadableObject methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:10'!
printedRepresentation

	^ printedRepresentation ! !

!LKNonReadableObject methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:10'!
printedRepresentation: aString

	printedRepresentation _ aString! !

!LKReader methodsFor: 'macros' stamp: 'spfa 11/18/2009 18:10'!
quote: aStream

	^ #quote inCons addLast: (self read: aStream)! !

!LKReader methodsFor: 'as yet unclassified' stamp: 'spfa 7/7/2010 14:53'!
read: aStream

	"this follows the algorithm described in
	Common Lisp the Language, 2nd edition, section 22.1.1"

	| x y token type ytype nme escflag caseMatters |

	token _ self token void.
	type _ #whiteSpace.
	nme _ 0.
	escflag _ false.
	caseMatters _ lisp ifNil: [true] ifNotNil: [lisp ignoresCase not].
	
	[type == #whiteSpace] whileTrue: [
"step 1"
		aStream atEnd ifTrue: [^ LKIOPort eof].
		x _ aStream next.
		type _ self class syntacticTypes at: (x asciiValue).
"step 4"
		(type == #terminatingMacro or: [type == #nonTerminatingMacro])
		ifTrue:	[	| val |
					val _ self perform: (self class macros at: x) with: aStream.
					val == self emptyListMarker ifTrue: [^ nil].
					val ifNotNil: [^ val].
					type _ #whiteSpace]].	
"step 5"
	type == #singleEscape 
		ifTrue: [token nextPut: aStream next. escflag _ true].
"step 6"
	type == #multipleEscape ifTrue: [nme _ nme + 1].
"step 7"	
	(nme even and: [type == #constituent]) 
		ifTrue: [token nextPut: (caseMatters ifFalse: [x asLowercase]
														ifTrue: [x])].
"step 8"
	[true] whileTrue: [	
		[nme even] whileTrue: [	
			y _ aStream peek.
			(y isNil "e.g.   aStream atEnd"
				or: [(ytype _ self class syntacticTypes at: (y asciiValue)) 
						== #terminatingMacro or: [ytype == #whiteSpace]])
 				ifTrue: [(nme isZero & escflag not) 
							ifFalse: [^ token contents asSymbol]
							ifTrue: [^ token parsed]].
			aStream next. 
			(ytype == #constituent or: [ytype == #nonTerminatingMacro])
				ifTrue: [token nextPut: (caseMatters ifFalse: [y asLowercase]
														ifTrue: [y])].
			ytype == #singleEscape 
				ifTrue: [token nextPut: aStream next. escflag _ true].
			ytype == #multipleEscape ifTrue: [nme _ nme + 1]].
"step 9"
		[nme odd] whileTrue: [	
			aStream atEnd ifTrue: [self error: 'missing escape'].
			y _ aStream next.
			ytype _ self class syntacticTypes at: (y asciiValue). 
			ytype == #multipleEscape 
				ifTrue: [nme _ nme + 1]
				ifFalse: [ ytype == #singleEscape
								ifTrue: [token nextPut: aStream next. escflag _ true]
								ifFalse: [token nextPut: y]]]].
! !

!LKReader methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
readString: aString

	^ self read: (ReadStream on: aString)! !

!LKIOPort methodsFor: 'proxy' stamp: 'spfa 11/18/2009 18:10'!
reset

	self stream reset! !

!LKReader methodsFor: '# macros' stamp: 'spfa 11/18/2009 18:10'!
sharpArray: aStream n: unused

	unused ifNotNil: [self error].

	self notYetImplemented! !

!LKReader methodsFor: '# macros' stamp: 'spfa 11/18/2009 18:10'!
sharpBalancedComment: aStream n: unused

	| c nc depth |

	unused ifNotNil: [self error].

	depth _ 0.

	[aStream atEnd] whileFalse:
	[
		c _ aStream next.
		nc _ aStream peek.
		(c == $# and: [nc == $|])
			ifTrue: [aStream next . depth _ depth + 1].
		(c == $| and: [nc == $#])
			ifTrue: 
			[
				aStream next.
				depth isZero ifTrue: [^ nil].
				depth _ depth - 1
			]
	].

	self error! !

!LKReader methodsFor: '# macros' stamp: 'spfa 11/18/2009 18:10'!
sharpBinaryRational: aStream n: unused

	unused ifNotNil: [self error].

	^ Number readFrom: (self read: aStream) asString base: 2! !

!LKReader methodsFor: '# macros' stamp: 'spfa 11/18/2009 18:10'!
sharpBitVector: aStream n: unused

	self notYetImplemented! !

!LKReader methodsFor: '# macros' stamp: 'spfa 11/18/2009 18:10'!
sharpCharacter: aStream n: unused

	| char |

	unused ifNotNil: [self error].

	aStream skip: -1.
	char _ (self read: aStream) asString.
	char size = 1 ifTrue: [^ char first].

	^ self class characterNames at: char asLowercase! !

!LKReader methodsFor: '# macros' stamp: 'spfa 11/18/2009 18:10'!
sharpComment: aStream n: unused

	unused ifNotNil: [self error].

	self read: aStream.
	^ nil! !

!LKReader methodsFor: '# macros' stamp: 'spfa 11/18/2009 18:10'!
sharpComplexNumber: aStream n: unused

	| cons |

	unused ifNotNil: [self error].

	cons _ self read: aStream.
	^ Complex real: cons car imaginary: cons cadr! !

!LKReader methodsFor: '# macros' stamp: 'spfa 11/18/2009 18:10'!
sharpFunction: aStream n: unused

	unused ifNotNil: [self error].

	^ #function inCons addLast: (self read: aStream)! !

!LKReader methodsFor: '# macros' stamp: 'spfa 11/18/2009 18:10'!
sharpHexaRational: aStream n: unused

	| hn c nc |
	
	unused ifNotNil: [self error].

	nc _ #($A $B $C $D $E $F).
	hn _ WriteStream on: ''.

	[(c _ aStream peek) notNil
		and: [c isDigit or: [nc identityIncludes: c asUppercase]]]
	whileTrue: [hn nextPut: aStream next].
	
	^ Number readFrom: hn contents asUppercase base: 16! !

!LKReader methodsFor: '# macros' stamp: 'spfa 11/18/2009 18:10'!
sharpLabel: aStream n: aNumber

	| v |

	aNumber ifNil: [self error: 'incorrect label syntax'].

	v _ self read: aStream.
	
	(self labels includesKey: aNumber)
		ifFalse: [self labels at: aNumber put: v]
		ifTrue: [(self labels at: aNumber) becomeForward: v].

	^ self labels at: aNumber! !

!LKReader methodsFor: '# macros' stamp: 'spfa 11/18/2009 18:10'!
sharpLabelReference: aStream n: aNumber 

	"if the reference is undefined at this point, let it be a dummy object to be replaced in place with the correct one later on (see the #becomeForward: call in #sharpLabel:n:"

	^ self labels at: aNumber 
			ifAbsent: [self labels at: aNumber put: {#badRef . aNumber}]! !

!LKReader methodsFor: '# macros' stamp: 'spfa 11/18/2009 18:10'!
sharpLoadTimeEvaluation: aStream n: unused

	unused ifNotNil: [self error].

	^ lisp eval: (self read: aStream) inCons! !

!LKReader methodsFor: 'macros' stamp: 'spfa 11/18/2009 18:10'!
sharpMacro: aStream

	| number key |

	[aStream peek isDigit] whileTrue:
		[number _ ((number ifNil: [0]) * 10) + (aStream next asciiValue - 48)].

	^ self perform: (key _ self class sharpMacros at: aStream next) 
		withArguments: {aStream . number}

! !

!LKReader class methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
sharpMacros 

	^ SharpMacros ! !

!LKReader methodsFor: '# macros' stamp: 'spfa 9/23/2010 10:10'!
sharpMethod: aStream n: unused

	unused ifNotNil: [self error].

	^ #send1! !

!LKReader methodsFor: '# macros' stamp: 'spfa 11/18/2009 18:10'!
sharpNonReadable: aStream n: unused

	unused ifNotNil: [self error].

	^ LKNonReadableObject new 
		printedRepresentation: (aStream upTo: $>) contents! !

!LKReader methodsFor: '# macros' stamp: 'spfa 11/18/2009 18:10'!
sharpOctalRational: aStream n: unused

	unused ifNotNil: [self error].

	^ Number readFrom: (self read: aStream) asString base: 8! !

!LKReader methodsFor: '# macros' stamp: 'spfa 11/18/2009 18:10'!
sharpPathName: aStream n: unused

	unused ifNotNil: [self error].

	self notYetImplemented! !

!LKReader methodsFor: '# macros' stamp: 'spfa 11/18/2009 18:10'!
sharpRadixNRational: aStream n: unused

	unused ifNotNil: [self error].

	self notYetImplemented! !

!LKReader methodsFor: '# macros' stamp: 'spfa 11/18/2009 18:10'!
sharpReadTimeEvaluation: aStream n: unused

	| sexp |

	unused ifNotNil: [self error].

	^ lisp eval: (sexp _ self read: aStream) inCons
! !

!LKReader methodsFor: '# macros' stamp: 'spfa 11/18/2009 18:10'!
sharpReadTimeUnless: aStream n: unused

	unused ifNotNil: [self error].

	self notYetImplemented! !

!LKReader methodsFor: '# macros' stamp: 'spfa 11/18/2009 18:10'!
sharpReadTimeWhen: aStream n: unused

	unused ifNotNil: [self error].

	self notYetImplemented! !

!LKReader methodsFor: '# macros' stamp: 'spfa 11/18/2009 18:10'!
sharpStructure: aStream n: unused

	unused ifNotNil: [self error].

	self notYetImplemented! !

!LKReader methodsFor: '# macros' stamp: 'spfa 11/18/2009 18:10'!
sharpUninternedSymbol: aStream n: unused

	unused ifNotNil: [self error].

	self notYetImplemented! !

!LKReader methodsFor: '# macros' stamp: 'spfa 11/18/2009 18:10'!
sharpVector: aStream n: aNumber

	| v |

	aStream skip: -1.
	v _ (self read: aStream) topForms.

	aNumber ifNotNil: 
	[
		v size > aNumber ifTrue: [self error: 'incorrect vector format'].
		v size < aNumber ifTrue:
		[  | nv |
			nv _ Array new: aNumber withAll: v last.
			1 to: v size - 1 do: [:n |
				nv at: n put: (v at: n)].
			v _ nv
		]
	].

	^ v.

	! !

!LKIOPort methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
status

	^ status ! !

!LKIOPort methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
status: aSymbol

	status _ aSymbol! !

!LKIOPort methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
stream

	^ self isInput ifTrue: [inStream] ifFalse: [outStream]
! !

!LKReader methodsFor: 'macros' stamp: 'spfa 4/16/2011 16:05'!
string: aStream

	| s |
	
	s _ String streamContents: [:str |
		| c |
		[c == $"] whileFalse:
		[
			c _ aStream next.
			(self class syntacticTypes at: c asciiValue) == #singleEscape
				ifTrue: [str nextPut: c; nextPut: aStream next]
				ifFalse: [c == $" ifFalse: [str nextPut: c]]
		]].

	^ (lisp ifNil: [^s]) class stringRepresentedBy: s
		
			
	! !

!LKReader class methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
syntacticTypes

	^ SyntacticTypes 
		! !

!LKReader methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
token

	^ LKToken! !

!LKReader methodsFor: 'macros' stamp: 'spfa 11/18/2009 18:10'!
unquote: aStream

	aStream peek == $@
		ifTrue: 
		[
			aStream next.
			^ #'unquote-splicing' inCons addLast: (self read: aStream)
		].

	^ #unquote inCons addLast: (self read: aStream)! !

!LKToken class methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
void

	^ (self on: '') initialize
	! !
LKReader initialize!
