


!Morph methodsFor: '*People-spfa-fixes' stamp: 'spfa 8/11/2010 18:02'!
containingWindow
	"Answer a window or window-with-mvc that contains the receiver"

	| component |
	component := self.
	component model isNil ifTrue: [component := self firstOwnerSuchThat: [:m| m model notNil]].
	^ ((component isNil or: [component isWindowForModel: component model])
		ifTrue: [component]
		ifFalse: [component firstOwnerSuchThat:[:m| m isWindowForModel: component model]])
		ifNil: [self firstOwnerSuchThat: [:m| m isSystemWindow]].! !

!Duration class methodsFor: '*People-spfa-fixes-override' stamp: 'brp 1/7/2004 15:38'!
days: days hours: hours minutes: minutes seconds: seconds nanoSeconds: nanos

 	^ self nanoSeconds: 
			( ( (days * SecondsInDay) 
				+ (hours * SecondsInHour)
					+ (minutes * SecondsInMinute) 
						+ seconds ) * NanosInSecond )
							+ nanos.
! !

!TestBrowser methodsFor: '*People-spfa-fixes' stamp: 'spfa 11/18/2009 18:17'!
defaultBrowserTitle
	"Returns the receivers default browser title"
	
	^self asString! !

!NCAAConnectorMorph class methodsFor: '*People-spfa-fixes' stamp: 'spfa 11/18/2009 18:14'!
defaultFSM

	^ nil! !

!Point methodsFor: '*People-spfa-fixes-override' stamp: 'spfa 11/18/2009 18:15'!
dist: aPoint 
	"Answer the distance between aPoint and the receiver."

	| dx dy |

	dx _ aPoint x - x.
	dy _ aPoint y - y.

	^ ((dx * dx) + (dy * dy)) sqrt! !

!SystemProgressMorph methodsFor: '*People-spfa-fixes' stamp: 'spfa 7/9/2010 12:03'!
freeSlot: number
	number > 0 ifTrue: [
		lock critical: [
			(bars at: number) delete.
			(labels at: number) delete.
			activeSlots := activeSlots - 1.
			activeSlots <= 0
				ifTrue: [self delete]
				ifFalse: [self recenter]]]! !

!Duration methodsFor: '*People-spfa-fixes-override' stamp: 'spfa 11/18/2009 18:09'!
hash 	

	^ seconds asInteger bitXor: nanos asInteger
! !

!FileList2 class methodsFor: '*People-spfa-fixes' stamp: 'spfa 11/18/2009 18:09'!
initialize
	Preferences
		addPreference: #useFileList2
		categories:  #(general)
		default: true
		balloonHelp: 'if true, then when you open a file list from the World menu, it''ll be an enhanced one'
		projectLocal:  false
		changeInformee:  self
		changeSelector: #useFileList2preferenceChanged
		viewRegistry: PreferenceViewRegistry ofBooleanPreferences ! !

!FileContentsBrowser methodsFor: '*People-spfa-fixes' stamp: 'spfa 11/18/2009 18:09'!
isTestCase: aPseudoClass

	^ false! !

!TestBrowser methodsFor: '*People-spfa-fixes' stamp: 'spfa 4/19/2010 15:08'!
layoutWithTestPane

	topWindowMorph removePanes.

	topWindowMorph 
		addMorph: self buildSystemCategoryListMorph frame: (0.0 @ 0.0 extent: 0.25 @ 0.23);
		addMorph: self buildTemplateMorph frame: (0.0 @ 0.23 extent: 0.25 @ 0.07);
"		addMorph: self buildToggleFilteringButtonMorph frame: (0.0 @ 0.23 extent: 0.12 @ 0.07);
		addMorph: self buildToggleTestPaneButtonMorph frame: (0.12 @ 0.23 extent: 0.13 @ 0.07);"
		addMorph: self buildClassListMorph frame: (0.25 @ 0.0 extent: 0.25 @ 0.30);
		addMorph: self buildMessageCategoryListMorph frame: (0.5 @ 0.0 extent: 0.25 @ 0.30);
		addMorph: self buildMessageListMorph frame: (0.75 @ 0.0 extent: 0.25 @ 0.30).

	topWindowMorph 
		addMorph: self buildRefreshButtonMorph frame: (0.0 @ 0.30 extent: 0.17 @ 0.12 "0.08");
		addMorph: self buildRunButtonMorph frame: (0.0 @ 0.42 "0.33" extent: 0.17 @ 0.17 "0.08");
		"addMorph: self buildStopButtonMorph frame: (0.0 @ 0.41 extent: 0.17 @ 0.08);"
		addMorph: self buildFailureButtonMorph frame: (0.17 @ 0.30 extent: 0.33 @ 0.07);
		addMorph: self buildFailuresListMorph frame: (0.17 @ 0.37 extent: 0.33 @ 0.22);
		addMorph: self buildErrorButtonMorph frame: (0.50 @ 0.30 extent: 0.33 @ 0.07);
		addMorph: self buildErrorListMorph frame: (0.50 @ 0.37 extent: 0.33 @ 0.22);
		addMorph: self buildRunCategoryButtonMorph frame: (0.83 @ 0.30 extent: 0.17 @ 0.08);
		addMorph: self buildRunClassButtonMorph frame: (0.83 @ 0.38 extent: 0.17 @ 0.08);
		addMorph: self buildRunMethodButtonMorph frame: (0.83 @ 0.46 extent: 0.17 @ 0.13).

	topWindowMorph 
		addMorph: self buildPassFailTextMorph frame: (0.0 @ 0.59 extent: 0.30 @ 0.07);
		addMorph: self buildDetailsTextMorph frame: (0.30 @ 0.59 extent: 0.70 @ 0.07).
	
	topWindowMorph 
		addMorph: self buildBrowserCodeMorph frame: (0.0 @ 0.66 extent: 1 @ 0.34).

	topWindowMorph setUpdatablePanesFrom: #(systemCategoryList classList messageCategoryList messageList).
	self refreshWindow.

	self isEmptySuite ifFalse: [self updateWindow].

	^ topWindowMorph! !

!ZipArchiveMember methodsFor: '*People-spfa-fixes-common' stamp: 'spfa 11/18/2009 18:17'!
localFileName
	"Answer my fileName in terms of the local directory naming convention"
	| localName |
	localName _  (fileName copyReplaceAll: '/' with: FileDirectory slash)
		copyReplaceAll: '\' with: FileDirectory slash.
	^(fileName first = $/)
		ifTrue: [ FileDirectory default class makeAbsolute: localName ]
		ifFalse: [ FileDirectory default class makeRelative: localName ]! !

!ExternalDropHandler methodsFor: '*People-spfa-fixes-override' stamp: 'spfa 11/18/2009 18:09'!
matchesExtension: aExtension
	(self extension isNil or: [aExtension isNil])
		ifTrue: [^false].
	FileDirectory activeDirectoryClass isCaseSensitive
		ifTrue: [^extension = aExtension]
		ifFalse: [^extension sameAs: aExtension]! !

!PolygonMorph methodsFor: '*People-spfa-fixes' stamp: 'spfa 11/18/2009 18:15'!
maybeBecomeNCLineMorph

	"for conversion from a connector v1.9 to a connector 2.2"

	| lw col o |

	(owner isNil or: [owner isConnector not]) ifTrue: [^ self].

	(owner isMGraphConnector and:
		[owner isTimeStamp]) ifTrue: [ lw _ 1] ifFalse: [lw _ 2].

	col _ borderColor.
	o _ owner.
	self privateOwner: nil.
	self become: ((NCLineMorph vertices: vertices lineWidth: lw lineColor: col borderWidth: 0 borderColor: col) privateOwner: o) 
		makeForwardArrow; fillStyle: col.

	owner beOrthogonal: false! !

!Duration class methodsFor: '*People-spfa-fixes-override' stamp: 'spfa 11/18/2009 18:09'!
milliSeconds: milliCount

	^ self nanoSeconds: milliCount * 1000000
! !

!Duration class methodsFor: '*People-spfa-fixes-override' stamp: 'spfa 11/18/2009 18:09'!
nanoSeconds: nanos

	| n s |

	n _ nanos asInteger.
	^ self new
		seconds: (s _ n quo: NanosInSecond) 
		nanoSeconds: (n - (s * NanosInSecond));
		yourself.
! !

!Object methodsFor: '*People-spfa-fixes' stamp: 'spfa 11/18/2009 18:15'!
perform: selector orSendTo: otherTarget
	"If I wish to intercept and handle selector myself, do it; else send it to otherTarget"
	(self respondsTo: selector)
		ifTrue: [^ self perform: selector]
		ifFalse: [^ otherTarget perform: selector]! !

!PolygonMorph methodsFor: '*People-spfa-fixes' stamp: 'spfa 11/18/2009 18:15'!
removeShortEndSegmentsStepping: something

	"used as a hook for on-the-fly conversion from a connector v1.9 to a connector 2.2"

	self maybeBecomeNCLineMorph.
	self removeShortEndSegmentsStepping: something! !

!FormCanvas methodsFor: '*People-spfa-fixes' stamp: 'spfa 4/30/2011 22:51'!
reset

	origin := 0@0.							"origin of the top-left corner of this cavas"
	clipRect := (0@0 corner: 100000@100000).		"default clipping rectangle"
	self shadowColor: nil.! !

!TestBrowser methodsFor: '*People-spfa-fixes' stamp: 'spfa 4/19/2010 14:49'!
runButtonColor

	^Color greenYellow! !

!Rectangle methodsFor: '*People-spfa-fixes' stamp: 'spfa 11/18/2009 18:16'!
storeOn: aStream 
	
	aStream nextPut: $(.
	self printOn: aStream.
	aStream nextPut: $)! !

!TestBrowser methodsFor: '*People-spfa-fixes' stamp: 'spfa 4/19/2010 14:07'!
systemCategoryList

	^filterMode 
		ifFalse: 
			[systemCategoryList := (systemOrganizer categories 
						select: [:each | self pattern match: each]) asArray]
		ifTrue: 
			[systemCategoryList ifNil: 
					[| testCategories |
					testCategories := self allTestCaseClasses collect: [:each | each category].
					systemCategoryList := (testCategories asSet
								select: [:each | self pattern match: each]) asArray]
				ifNotNil: [systemCategoryList]]! !
