SystemOrganization addCategory: #REPLMorph!


TextMorphEditor subclass: #REPLTextMorphEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'REPLMorph'!

TextMorphForEditView subclass: #REPLTextMorphForEditView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'REPLMorph'!

Object subclass: #NotebookCell
	instanceVariableNames: 'start end endInput notebook promptMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'REPLMorph'!

PluggableTextMorphWithModel subclass: #REPLMorph
	instanceVariableNames: 'evaluator commandsHistory lastAnswer lastError debugContinuation lastValue queue outputQueueProcess semaphore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'REPLMorph'!

REPLMorph subclass: #Notebook
	instanceVariableNames: 'geometriesCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'REPLMorph'!

PluggableTextMorph subclass: #REPLPluggableTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'REPLMorph'!

REPLPluggableTextMorph class
	instanceVariableNames: ''!

REPLTextMorphEditor class
	instanceVariableNames: ''!

NotebookCell class
	instanceVariableNames: ''!

REPLTextMorphForEditView class
	instanceVariableNames: ''!

REPLMorph class
	instanceVariableNames: ''!

Notebook class
	instanceVariableNames: ''!


!Notebook commentStamp: 'spfa 4/4/2010 00:25' prior: 0!
A Notebook is a mutated REPLMorph which allows nice formatting of the expressions output (notably the embedding of output morphs), along with operations on cells (each couple expression/output forms a NotebookCell) such as trimming, reordering and commenting !
]style[(259)!

!REPLMorph commentStamp: '<historical>' prior: 0!
a PluggableTextMorph providing a read-eval-print loop for interaction with an interpreter or compiler, called evaluator

evaluator must provide a #prompt, an #outputStream and an #evalString: method !
]style[(199)!

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/18/2009 18:16'!
acceptDroppingMorph: aMorph event: evt inMorph: dstListMorph 
	
	| commands |

	(aMorph hasProperty: #replCommands) ifFalse: [^ self].

	commands _ (aMorph valueOfProperty: #replCommands) 					difference: self commandsHistory.

	((commands size > 1
		and: [self confirm: 'Add these ', commands size asString, ' commands to history ?'])
	or: [(commands size = 1
		and: [self confirm: 'Add this command to history ?'])])
		ifFalse: [^ self addMorph: aMorph].

	commands do: [:command | self registerCommand: command].
	^ true

! !

!Notebook methodsFor: 'contents' stamp: 'spfa 4/1/2010 13:50'!
acceptTextInModel

	| cell |

	self text indexOf: (Character value: 1) startingAt: selectionInterval last 
		ifAbsent: [^ super acceptTextInModel].

	"update targeted cell, if any"
	cell _ NotebookCell at: (self text embeddedMorphsIndexes 
			reverseDetect: [:a |
				a key < selectionInterval last  
					and: [a value hasProperty: #notebookPrompt]]
			ifNone: [^ false]) value.
	self registerCommand: cell liveInput.
	cell refresh.

	self getProperty: #refreshDisplay. "else the prompt does not show up"

	^ true! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 11/18/2009 18:16'!
acceptTextInModel

	| textToAccept command |

	(self hasProperty: #inCommand)
	ifFalse:
	[
		command _ self currentCommandFor: textMorph contents.
		command ifEmpty: [command _ self pointedCommand].
		(command isNil or: [command isEmpty]) ifTrue: [^ self].
		self insertCommand: command.
	].

	textToAccept := textMorph asText.
	^setTextSelector isNil or:
		[setTextSelector numArgs = 2
			ifTrue: [model perform: setTextSelector with: textToAccept with: self]
			ifFalse: [model perform: setTextSelector with: textToAccept]]
! !

!Notebook methodsFor: 'display stream protocol' stamp: 'spfa 4/2/2010 09:09'!
adaptCommand: aString

	^ aString! !

!Text methodsFor: '*REPLMorph' stamp: 'spfa 11/18/2009 18:17'!
addAttributes: anArray

	anArray do: [:att | self addAttribute: att]! !

!Text methodsFor: '*REPLMorph' stamp: 'spfa 11/18/2009 18:17'!
addAttributes: anArray from: anIndex to: bIndex

	anArray do: [:att | self addAttribute: att  from: anIndex to: bIndex]! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 8/11/2010 22:19'!
addCell: input comment: comment status: aSymbol

	self updateText: myContents, 
		(self cellTextWithInput: input status: aSymbol), String cr asText.

	self refreshDisplay: ''.

	comment ifNil: [^ self].
	self lastCell prependComment: comment asText! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 4/3/2010 23:33'!
addControlButtonsTo: controls for: aMorph

	
! !

!Notebook methodsFor: 'menu' stamp: 'spfa 4/3/2010 18:15'!
addItemsToREPLMenu: aMenu

	super addItemsToREPLMenu: aMenu.

	aMenu 
		add: 'explore bindings' target: evaluator bindings action: #explore! !

!Notebook methodsFor: 'menu' stamp: 'spfa 11/18/2009 18:14'!
addREPL

	self changeGeometry: [:sw |
		sw addMorph: self frame: (0@0 corner: 0.5@1).
		sw addMorph: (REPLMorph on: self evaluator) frame: (0.5@0 corner: 1@1)]

	! !

!Notebook methodsFor: 'menu' stamp: 'spfa 11/18/2009 18:14'!
addWREPL

	| wks |

	wks _ PluggableTextMorph 
			on: self evaluator text: nil 
			accept: #evalText:from: readSelection: nil menu: nil.

	self changeGeometry: [:sw |
		sw addMorph: self frame: (0@0 corner: 0.5@1).
		sw addMorph: wks frame: (0.5@0 corner: 1@0.5).
		sw addMorph: (REPLMorph on: self evaluator) 
			frame: (0.5@0.5 corner: 1@1)]

	! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 11/18/2009 18:14'!
anew

	^ self class at: promptMorph! !

!REPLMorph class methodsFor: 'colors' stamp: 'spfa 11/18/2009 18:16'!
answerAttributes

	^ {TextColor color: Color gray darker}! !

!REPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 11/18/2009 18:16'!
appendEntry

	| stream text |

	stream := evaluator outputStream.
	stream isEmpty ifTrue: [^ self].

	text := stream contents.
	stream resetContents.
	
	self queue nextPut: ((text asString copyReplaceAll: String lf with: String cr)
		asText 
			addAttribute: self class displayAttribute;
			addAttribute: self class displayFontAttribute).
! !

!NotebookCell class methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:14'!
at: aMorph
	
	^ self new initializeAt: aMorph! !

!Notebook methodsFor: 'menu' stamp: 'spfa 11/7/2010 19:48'!
buildMenu: aMenu

	super buildMenu: aMenu.

	aMenu add: textMorph acceptOnCR yesNoString, 'accept on CR'
		target: (self lambda acceptOnCR: textMorph acceptOnCR not)
		action: #value.

	aMenu addLine;
		add: 'remove all output' target: self action: #removeAllOutput;
		add: 'evaluate all cells' target: self action: #evaluate;
		add: 'copy from cells' target: self action: #rewritedFromCells;
		add: 'edit a copy from cells' target: self action: #editCopyFromCells.		.

	(self hasProperty: #storage) ifTrue: [
		| m |
		m _ self valueOfProperty: #storage.
		aMenu addLine.
		aMenu add: 'store in ', m receiver asString, '>>', m selector
			target: (self lambda storeAsSelector: m selector in: m receiver)
			action: #value
	].

	(owner isSystemWindow
		and: [(self hasProperty: #disallowGeometryChanges) not]) 
	ifTrue: [
		aMenu addLine.
		(owner submorphs count: [:m | m isMorphicModel]) = 1 ifTrue: [
			aMenu add: 'add REPL' target: self action: #addREPL.
			aMenu add: 'add REPL and workspace' target: self action: #addWREPL.
			aMenu add: 'add dual notebook' target: self action: #dual]
		ifFalse: [aMenu add: 'go full frame' target: self action: #fullFrame].
	].

	^ aMenu
! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/9/2010 15:46'!
buildMenu: aMenu

	self commandsHistory do: [:command |
		| str |
		str := command asString withBlanksTrimmed.
		aMenu add: (str truncateWithElipsisTo: 70)
				selector: #insertCommand: argument: str].

	self commandsHistory ifNotEmpty: [aMenu addLine].

	lastAnswer ifNotNil: [
		self proposeLastAnswer ifTrue: [
			| str |
			str := lastAnswer asString withBlanksTrimmed.
			str isEmpty ifFalse: [
				aMenu add: (str truncateWithElipsisTo: 70)
					selector: #insertCommand: argument: str]].
		aMenu add: 'explore last value' target: lastValue selector: #explore].

	evaluator addItemsToREPLMenu: aMenu.

	aMenu addLine.
	commandsHistory isEmpty ifTrue: [aMenu add: 'no history yet' action: #yourself]
		ifFalse: [
			aMenu addLine;
			add: 'display history' action: #displayHistory;
			add: 'grab history' action: #grabHistory].

	aMenu add: 'clear display' action: #clear.
			
	debugContinuation ifNotNil: [
		aMenu addLine.
		aMenu add: (('DEBUG ', lastError) truncateWithElipsisTo: 70)
			 target: debugContinuation selector: #value].

	^ aMenu! !

!REPLPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:16'!
buildMenu: aMenu

	model buildMenu: aMenu.
	^ aMenu! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 8/11/2010 14:46'!
buttonMorph
	
	^ StrongButtonMorph newWithRoundedCorner
		actWhen: #buttonDown;	
		color: Color whiteSmoke;
		borderColor: Color cornflowerBlue! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 8/11/2010 22:18'!
cellTextWithInput: input status: aSymbol

	^ (self prompt: aSymbol), 
		(input asText addAttributes: self class commandAttributes), 
		String cr asText, self separator! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 11/18/2009 18:14'!
cellsDo: aBlock

	(self getMyText embeddedMorphsList select: [:m |
		m hasProperty: #notebookPrompt])
		do: [:pm | aBlock value: (NotebookCell at: pm)].
! !

!Notebook methodsFor: 'menu' stamp: 'spfa 11/18/2009 18:14'!
changeGeometry: aBlock

	| po am |

	(po _ owner) isSystemWindow ifFalse: [^ self].
	am _ po submorphs first.
	po removeAllMorphs.
	aBlock value: po.
	po addMorphFront: am
	! !

!Notebook methodsFor: 'private' stamp: 'spfa 11/27/2010 21:03'!
characterLimit

	^ Float infinity! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 11/18/2009 18:16'!
characterLimit

	"we should be able to set this interactively"

	^ 30000! !

!Notebook methodsFor: 'contents' stamp: 'spfa 3/21/2010 17:50'!
checkUpCells

	((self hasProperty: #swap) or:[self hasProperty: #insert]) ifTrue: [^ self]. 

	self cellsDo: [:c | 
		c promptMorph color: ((c promptMorph valueOfProperty: #status) 
			caseOf: {
				[nil] -> [self buttonMorph color].
				[#trigger] -> [Color gold lighter lighter].
				[#interactive] -> [Color yellowGreen lighter lighter]})]! !

!Notebook methodsFor: 'contents' stamp: 'spfa 11/18/2009 18:14'!
clear

	self updateText: '' asText; 
			refreshDisplay: self prompt! !

!REPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 11/18/2009 18:16'!
clear

	self updateText: '' "self prompt".
	self refreshDisplay: self prompt.! !

!Notebook class methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:14'!
commandAttributes

	^ {TextColor color: Color blue muchDarker . "TextEmphasis bold"}! !

!REPLMorph class methodsFor: 'colors' stamp: 'spfa 11/18/2009 18:16'!
commandAttributes

	^ {TextColor color: Color blue muchDarker}! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/18/2009 18:16'!
commandsHistory

	^ commandsHistory ifNil: [commandsHistory _ OrderedCollection new]
! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 11/18/2009 18:14'!
comment

	^ (notebook getMyText embeddedMorphsIndexes reverseDetect: [:array |
		array key < start and: [
			(array value hasProperty: #notebookPrompt) ifTrue: [^ nil].
			array value hasProperty: #notebookComment]]
		ifNone: [^ nil]) value! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 11/18/2009 18:14'!
commentColor

	^ Color grey alpha: 0.1

! !

!Notebook methodsFor: 'storage' stamp: 'spfa 5/23/2010 23:18'!
constructor

	^ String streamContents: [:str |
		self class storeOn: str.
		str nextPutAll: ' new: '.
		self headerLabel storeOn: str. 
		str cr.
		str tab; tab; nextPutAll: 'contents: #( '; cr.
		self stringContents do: [:cell |
			str tab; tab; tab.
			cell isString ifTrue: [cell storeOn: str].
			cell isArray ifTrue: [str nextPutAll: cell printString allButFirst].
			str cr].
		str tab; tab; nextPutAll: ')'].


! !

!Notebook methodsFor: 'storage' stamp: 'spfa 4/2/2010 11:10'!
contents

	^ Array streamContents: [:str |
		self cellsDo: [:cell | 
			| comment |
			((comment _ cell comment) isNil and: [cell status isNil])
				ifTrue: [str nextPut: cell inputString]
				ifFalse: [
					str nextPut: {
							comment ifNotNil: [comment contents asString].
							cell inputString.
							cell status
						}]]]
! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 11/18/2009 18:14'!
contents

	| text |

	text _ notebook getMyText.

	end = text size ifTrue:
		[^ text copyFrom: start to: end].

	^ text copyFrom: start to: end -1! !

!Notebook methodsFor: 'contents' stamp: 'spfa 11/7/2010 19:30'!
controlsWrapper

	^ self morphWrapper cellInset: 1; layoutInset: 1! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 8/11/2010 15:08'!
copyComment

	notebook setProperty: #cutComment toValue: (self comment ifNil: [^ self]) contents.
! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 11/18/2009 18:14'!
crop

	self replaceFrom: start-1 to: end with: ''.
	self comment ifNotNil: [self removeComment].
! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/18/2009 18:16'!
currentCommandFor: text

	| lastLinePos lastLine  |

	lastLinePos _ text lastIndexOfSubCollection: (String cr, self promptString)  ifAbsent: [0].
"	lastLinePos _ text lastIndexOf: Character cr ifAbsent: [ 0 ]."
	lastLinePos _ text asString skipAnySubStr: {self promptString} startingAt: lastLinePos + 1.
	lastLine _ text copyFrom: lastLinePos to: text size.
	^ lastLine asString withBlanksTrimmed! !

!REPLTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:16'!
cursorPageDown: characterStream 

	self isOnPromptLine
		ifTrue: [model insertNextCommand. ^ true].

	^ super cursorPageDown: characterStream ! !

!REPLTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:16'!
cursorPageUp: characterStream 

	self isOnPromptLine
		ifTrue: [model insertPreviousCommand. ^ true].

	^ super cursorPageUp: characterStream ! !

!REPLMorph class methodsFor: 'colors' stamp: 'spfa 11/18/2009 18:16'!
displayAttribute

	^ TextColor color: Color red muchDarker muchDarker! !

!REPLMorph class methodsFor: 'colors' stamp: 'spfa 11/18/2009 18:16'!
displayFont

	^ ((TextStyle named: #Accumon) ifNil: [^ TextStyle defaultFont])
		fontOfSize: TextStyle defaultFont pointSize! !

!REPLMorph class methodsFor: 'colors' stamp: 'spfa 11/18/2009 18:16'!
displayFontAttribute

	^ TextFontReference toFont: self displayFont! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 9/20/2010 09:59'!
displayHistory

	StringHolder new 
		acceptContents: (String streamContents: [:str |
			self commandsHistory do: [:command |
				str nextPutAll: command; cr]]); 
		openLabel: 'commands history'
	! !

!Notebook methodsFor: 'display stream protocol' stamp: 'spfa 4/2/2010 13:50'!
doCommand: aString

	self doCommand: aString register: true! !

!REPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 11/21/2010 11:19'!
doCommand: aString

	| answer |

	self setProperty: #inCommand toValue: true.
	self registerCommand: aString.

	debugContinuation := lastAnswer := lastError := lastValue :=  nil.

	answer :=  [lastAnswer := (self formatAnswer: 
						(lastValue := self evalString: aString)) 
								asText addAttributes: self class answerAttributes]
		on: Error
		do: [:ex | 
				debugContinuation := Continuation current.
				debugContinuation isContinuation
					ifTrue: [(lastError := ex description) asText 
								addAttribute: self class errorAttribute]
					ifFalse: [ex signal]].

	self setProperty: #inCommand toValue: false.

	self appendEntry; outputQueue.
	self updateText: myContents, answer, String cr.
	self refreshDisplay: self prompt.

! !

!Notebook methodsFor: 'display stream protocol' stamp: 'spfa 8/14/2010 23:00'!
doCommand: aString register: rflag

	| answer |

	self setProperty: #inCommand toValue: true.
	rflag ifTrue: [self registerCommand: aString].

	debugContinuation := lastAnswer := lastError := lastValue :=  nil.

	answer _  (self evalCommand: aString) asText
					addAttributes: self class answerAttributes.

	self setProperty: #inCommand toValue: false.

	self appendEntry; outputQueue.
	self updateText: (aString last == $. 
		ifTrue: [myContents, self separator, String cr]
		ifFalse: [myContents, self separator, answer, String cr, String cr]).
	self refreshDisplay: self prompt.

	self selectFrom: self text size + 1 to: self text size + 1.
	self scrollSelectionIntoView; setScrollDeltas; refreshWorld.


! !

!Notebook methodsFor: 'menu' stamp: 'spfa 4/2/2010 09:33'!
dual

	self dual: (Notebook new evaluator: self evaluator) clear
		
	! !

!Notebook methodsFor: 'menu' stamp: 'spfa 4/2/2010 09:33'!
dual: aNotebook

	self changeGeometry: [:sw |
		sw addMorph: self frame: (0@0 corner: 0.5@1).
		sw addMorph: aNotebook
				frame: (0.5@0 corner: 1@1).]

	! !

!Notebook methodsFor: 'storage' stamp: 'spfa 5/23/2010 23:24'!
editCopyFromCells

	('(', self constructor, ') openInWorld') openInWorkspaceWithTitle: self headerLabel, ' (edit)'
! !

!REPLTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:16'!
encompassLine: anInterval
	"Return an interval that encompasses the entire line, minus the promt if present at the beginning"

	| string left right |
	string _ paragraph text string.
	left _ (string lastIndexOf: Character cr startingAt: anInterval first - 1 ifAbsent:[0]) + 1.

	left == 
		(string indexOfSubCollection: model promptString startingAt: left ifAbsent: [nil]) 
	ifTrue: [left _ left + model promptString size].

	right _ (string indexOf: Character cr startingAt: anInterval last + 1 ifAbsent: [string size + 1]) - 1.
	^left to: right! !

!REPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 11/18/2009 18:16'!
endEntry

	self appendEntry.
	(outputQueueProcess notNil
		and: [outputQueueProcess isTerminated not]) ifTrue: [^ self].

	outputQueueProcess _ [50 milliSeconds asDelay wait . self outputQueue] fork
! !

!REPLMorph class methodsFor: 'colors' stamp: 'spfa 11/18/2009 18:16'!
errorAttribute

	^ TextColor color: Color red! !

!Notebook methodsFor: 'display stream protocol' stamp: 'spfa 11/18/2009 18:14'!
evalCommand: aString

	^  [lastAnswer := 
						(lastValue := evaluator evalString: aString notifying: self)
					forNotebook: self]
		on: Error
		do: [:ex | 
				debugContinuation := Continuation current.
				debugContinuation isContinuation
					ifTrue: [(lastError := ex description) asText 
								addAttribute: self class errorAttribute]
					ifFalse: [ex signal]]! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/21/2010 11:19'!
evalString: aString

	(self hasProperty: #commandController)
		ifTrue: [(self valueOfProperty: #commandController) checkCommand: aString].

	^ evaluator evalString: aString notifying: self! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 11/18/2009 18:16'!
evalText: aString

	^ evaluator evalText: aString! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 3/21/2010 17:01'!
evaluate

	self cellsDo: [:cell | cell evaluateFromNotebook]
! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 3/21/2010 17:14'!
evaluate

	self evaluateSansTrigger.
	self isTrigger ifTrue: [^ notebook evaluateSans: self].
	! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 3/21/2010 17:03'!
evaluateFromNotebook

	(self isPassive or: [self isTrigger]) ifFalse: [^ self].

	self evaluateSansTrigger
! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 3/21/2010 17:15'!
evaluateSans: aNotebookCell

	self cellsDo: [:cell | 
		aNotebookCell == cell ifFalse:
			[cell evaluateFromNotebook]]
! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 4/3/2010 23:11'!
evaluateSansTrigger

	| input val |
	
	input _ self input asString withBlanksTrimmed.
	input ifEmpty: [^ self].	

	val _ (notebook evalCommand: input) asText 
			addAttributes: notebook class answerAttributes.

	input last == $. ifTrue:
		[^ self output: String cr].

	self output: val, String cr, String cr! !

!REPLTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:16'!
evaluateSelection
	"Treat the current selection as an expression; evaluate it and return the result"

	self lineSelectAndEmptyCheck: [^ ''].
	^ model evalString: self selectionAsStream contents asString! !

!REPLMorph methodsFor: 'initialization' stamp: 'spfa 11/18/2009 18:16'!
evaluator

	^evaluator
! !

!REPLMorph methodsFor: 'initialization' stamp: 'spfa 11/18/2009 18:16'!
evaluator: anObject

	| fresh |

	(self hasProperty: #inCommand) ifTrue: [^ self].

	fresh _ ''.

	evaluator ifNotNil: [
		self appendEntry; outputQueue.
		fresh _ self freshInput. 
		[fresh beginsWith: String cr] whileTrue: [fresh _ fresh allButFirst].
		(fresh beginsWith: self prompt) 
			ifTrue:	[fresh _ fresh allButFirst: self prompt size]].

	evaluator := anObject.
	self appendEntry; outputQueue.
	evaluator outputStream reset.

	self refreshDisplay: self prompt, fresh

! !

!Notebook methodsFor: 'contents' stamp: 'spfa 11/18/2009 18:14'!
extent: aPoint

	super extent: aPoint.

	textMorph ifNil: [^ self]. "notebook is not fully initialized yet"
	self refreshDisplay: self prompt.! !

!Form methodsFor: '*REPLMorph' stamp: 'spfa 11/18/2009 18:10'!
forNotebook: aNotebook

	^ self asMorph forNotebook: aNotebook
! !

!Morph methodsFor: '*REPLMorph' stamp: 'spfa 4/2/2010 09:37'!
forNotebook: aNotebook

	(self == World or: [owner notNil])
		ifTrue: [^ (self printString, ' [owner: ', owner printString, ']') asText].

	^ aNotebook wrapMorphForOutput: self
! !

!Object methodsFor: '*REPLMorph' stamp: 'spfa 8/14/2010 23:03'!
forNotebook: aNotebook

	^ aNotebook wrapForOutput: self
! !

!SimpleButtonMorph methodsFor: '*REPLMorph' stamp: 'spfa 11/18/2009 18:16'!
forNotebook: aNotebook

	^ aNotebook plainOutput: self
! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/18/2009 18:16'!
formatAnswer: anObject

	^ anObject printString
	

	

	! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 11/18/2009 18:16'!
freshInput

	| len tlen |

	len _ myContents ifNil: [0] ifNotNil: [myContents size].
	tlen _ textMorph asText size.
	tlen == len ifTrue: [^ ''].

	^ textMorph asText copyFrom: len to: textMorph asText size

! !

!Notebook methodsFor: 'menu' stamp: 'spfa 11/18/2009 18:14'!
fullFrame

	self changeGeometry: [:sw |
		sw addMorph: self frame: (0@0 corner: 1@1)]

	! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 12/11/2010 00:26'!
getButton

	| input  |
	
	input _ self input asString withBlanksTrimmed.
	input ifEmpty: [^ self].	

	(SimpleButtonMorph newWithRoundedCorner
		target: notebook;
		actionSelector: #evalCommand:;
		arguments: {input};
		label: input allButFirst;
		color: Color whiteSmoke;
		borderColor: Color cornflowerBlue) openInHand! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 11/18/2009 18:16'!
getMyText
	^myContents! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 4/2/2010 14:51'!
getValue

	^ notebook evalString: self input asString withBlanksTrimmed! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/18/2009 18:16'!
grabHistory

	| n |

	n _  self commandsHistory size.
	n > 0 ifFalse: [^ self].

	((StringMorph contents: n asString, ' command', (n>1 ifTrue: ['s'] ifFalse: ['']))
		setProperty: #replCommands toValue: self commandsHistory)
	openInHand
! !

!Notebook methodsFor: 'header' stamp: 'spfa 11/18/2009 18:14'!
headerFont

	^ TextStyle default fontOfSize: 30! !

!Notebook methodsFor: 'header' stamp: 'spfa 11/18/2009 18:14'!
headerLabel

	owner ifNil: [^ ''].

	^ owner label
! !

!Notebook methodsFor: 'header' stamp: 'spfa 4/2/2010 11:52'!
headerText

	^ Text streamContents: [:str |

		| label sbutt sabutt ebutt bbutt space |

		label _ MPEGSubtitlesDisplayer on: self selector: #headerLabel.
		label font: self headerFont.
		str nextPutAll: label asAnchoredText.

		str cr.

		sbutt _ self buttonMorph label: 'save'; 
			target: self lambda owner saveOnUsualFile; 
			actionSelector: #value.
		str nextPutAll: sbutt asAnchoredText.

		str nextPutAll: '  ' asText.

		sabutt _ self buttonMorph label: 'save as...'; 
			target: self lambda owner saveOnFileRememberWhere; 
			actionSelector: #value.
		str nextPutAll: sabutt asAnchoredText.

		str nextPutAll: (Morph new 
				color: Color transparent; height: 10) asAnchoredText.

		ebutt _ self buttonMorph label: 'evaluate'; 
			target: self ; 
			actionSelector: #evaluate.
		str nextPutAll: ebutt asAnchoredText.

		str nextPutAll: '  ' asText.

		bbutt _ self buttonMorph label: 'bindings'; 
			target: self lambda evaluator bindings quoted explore ; 
			actionSelector: #value.
		str nextPutAll: bbutt asAnchoredText.

		str cr; cr]

! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 11/18/2009 18:14'!
hideOutput

	| hbutt |

	hbutt _ notebook buttonMorph label: 'show';
					target: (self lambda anew output: self output); 
					actionSelector: #value.

	^ self output: hbutt asAnchoredText, String cr, String cr
! !

!REPLMorph class methodsFor: 'as yet unclassified' stamp: 'spfa 4/3/2010 18:23'!
historyLength

	^ 15! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 11/18/2009 18:14'!
inSystemWindow

	^ self inSystemWindowLabelled: 'notebook'
! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 11/28/2010 21:00'!
inSystemWindowLabelled: aString

	| w |

	w _ SystemWindow labelled: aString.
	w model: self.
	w paneColor: self class windowColor.
	w addMorph: self frame: (0@0 corner: 1@1).
	^ w! !

!Notebook methodsFor: 'initialization' stamp: 'spfa 11/28/2010 21:39'!
initialExtent

	^ 620@400! !

!Notebook methodsFor: 'initialization' stamp: 'spfa 11/18/2009 18:14'!
initialize

	super initialize.
	self getProperty: #alwaysAccept.
	self updateText: self headerText.

! !

!REPLMorph methodsFor: 'initialization' stamp: 'spfa 11/18/2009 18:16'!
initialize
	super initialize.
	self extent: 600@400.
	self color: Color white.
	self acceptOnCR: true.
"	self alwaysShowVScrollBar: true."
	getMenuSelector := #buildMenu:.
	self startStepping



	! !

!NotebookCell methodsFor: 'intialization' stamp: 'spfa 11/18/2009 18:14'!
initializeAt: aMorph

	| text emorphs |

	promptMorph _ aMorph.

	notebook _ promptMorph ownerChain detect: [:m | m isMorphicModel].
	text _ notebook getMyText.

	emorphs _ text embeddedMorphsIndexes.

	start _ (emorphs detect: [:a |
		a value == promptMorph] ifNone: [^ nil]) key.

	end _ (emorphs detect: [:a |
		a key > start 
			and: [(a value hasProperty: #notebookPrompt)
					or: [a value hasProperty: #notebookComment]]]
		ifNone: [text size -> #theEnd]) key.

	endInput _ (text indexOf: notebook separator first 
					startingAt: start ifAbsent: []) -1.
! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 11/18/2009 18:14'!
input

	notebook class commandAttributes do: [:att |
		notebook getMyText addAttribute: att from: start + 1 to: endInput].

	^ notebook getMyText copyFrom: start + 1 to: endInput
			 ! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 11/18/2009 18:14'!
input: aText

	^ self replaceFrom: start+1 to: endInput with: aText! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 11/18/2009 18:14'!
inputString

	^ (notebook getMyText asString copyFrom: start + 1 to: endInput - 1)
		withBlanksTrimmed
			 ! !

!Notebook methodsFor: 'contents' stamp: 'spfa 3/24/2010 15:12'!
insert: aMorph

	aMorph setProperty: #passiveColor toValue: aMorph color.
	self setProperty: #insert toValue: aMorph.
	aMorph color: Color orange! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 8/11/2010 22:16'!
insertBefore: aButtonMorph
	
	| promptMorph tempText first fc sc |

	promptMorph _ self valueOfProperty: #insert.
	self removeProperty: #insert.
	promptMorph color: (promptMorph valueOfProperty: #passiveColor).
	promptMorph == aButtonMorph ifTrue: [^ self].

	(self hasProperty: #swapComments) ifTrue: [	
		fc _ (NotebookCell at: promptMorph) comment.
		sc _ (NotebookCell at: aButtonMorph) comment].

	first _ (NotebookCell at: promptMorph).
	tempText _ first contents allButLast.
	first crop.
	(NotebookCell at: aButtonMorph) prepend: String cr asText, tempText.	

	(self hasProperty: #swapComments) ifTrue: [		
		sc ifNotNil: [(NotebookCell at: promptMorph) removeComment].
		sc ifNotNil: [(NotebookCell at: aButtonMorph) prependComment: sc contents].	
		fc ifNotNil: [(NotebookCell at: promptMorph) prependComment: fc contents]].			
	
! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 8/12/2010 02:05'!
insertCell

	self prepend: String cr asText, (notebook cellTextWithInput: '' status: nil)! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/18/2009 18:16'!
insertCommand: aString

	textMorph newContents: (Text streamContents: [:str |

		| txt |

		str nextPutAll: (myContents ifNil: ['']).

		(self hasProperty: #inCommand) ifFalse: [
			myContents isEmptyOrNil ifFalse: [
				myContents last == Character cr ifFalse: [str cr]].
			str nextPutAll: self prompt].

		txt _ (Text fromString: aString) 
					addAttributes: self class commandAttributes.
		(self hasProperty: #inCommand) 
			ifTrue: [txt addAttribute: self class displayFontAttribute].
		str nextPutAll: txt]).

	textMorph editor selectAt: textMorph asText size + 1.
	self hasUnacceptedEdits: true! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/18/2009 18:16'!
insertNextCommand

	| command |
	self commandsHistory ifEmpty: [^ self].
	self insertCommand: (command _ commandsHistory first).
	commandsHistory removeFirst.
	commandsHistory addLast: command! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/18/2009 18:16'!
insertPreviousCommand

	| command |
	self commandsHistory ifEmpty: [^ self].
	self insertCommand: (command _ commandsHistory last).
	commandsHistory removeLast.
	commandsHistory addFirst: command! !

!REPLTextMorphForEditView methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:16'!
installEditorToReplace: priorEditor
	"Install an editor for my paragraph.  This constitutes 'hasFocus'.
	If priorEditor is not nil, then initialize the new editor from its state.
	We may want to rework this so it actually uses the prior editor."

	| stateArray |
	priorEditor ifNotNil: [stateArray := priorEditor stateArray].
	editor := REPLTextMorphEditor new morph: self.
	editor changeParagraph: self paragraph.
	priorEditor ifNotNil: [editor stateArrayPut: stateArray].
	self selectionChanged.
	^ editor! !

!NotebookCell methodsFor: 'menu' stamp: 'spfa 3/21/2010 17:16'!
isInteractive

	^ (promptMorph valueOfProperty: #status) == #interactive! !

!REPLTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:16'!
isOnPromptLine

	^ self isPromptLine: self selectionInterval
! !

!NotebookCell methodsFor: 'menu' stamp: 'spfa 3/21/2010 17:16'!
isPassive

	^ (promptMorph valueOfProperty: #status) isNil! !

!REPLTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:16'!
isPromptLine: anInterval

	| string left |
	string _ paragraph text string.
	left _ (string lastIndexOf: Character cr startingAt: anInterval first - 1 ifAbsent:[0]) + 1.

	^ left == 
		(string indexOfSubCollection: model prompt startingAt: left ifAbsent: [nil]) 
! !

!NotebookCell methodsFor: 'menu' stamp: 'spfa 3/21/2010 17:16'!
isTrigger

	^ (promptMorph valueOfProperty: #status) == #trigger! !

!REPLTextMorphForEditView methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:16'!
keyStroke: evt
	
"	editView lisp standardInput stream nextPut: evt keyCharacter."
	super keyStroke: evt! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 11/18/2009 18:14'!
lastCell

	^ NotebookCell at: (myContents embeddedMorphsList reverseDetect: [:m | 
								m hasProperty: #notebookPrompt])! !

!SequenceableCollection methodsFor: '*REPLMorph' stamp: 'spfa 11/18/2009 18:16'!
lastIndexOfSubCollection: sub ifAbsent: exceptionBlock
	"Answer the index of the receiver's last element, such that that element 
	equals the first element of sub, and the next elements equal 
	the rest of the elements of sub. Begin the search at element 
	end of the receiver. If no such match is found, answer the result of 
	evaluating argument, exceptionBlock."
	| first index |
	sub isEmpty ifTrue: [^ exceptionBlock value].
	first _ sub first.
	self size - sub size + 1 to: 1 by: -1 do:
		[:startIndex |
		(self at: startIndex) = first ifTrue:
			[index _ 1.
			[(self at: startIndex+index-1) = (sub at: index)]
				whileTrue:
				[index = sub size ifTrue: [^startIndex].
				index _ index+1]]].
	^ exceptionBlock value! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 11/18/2009 18:14'!
liveInput

	| ibeg iend |

	ibeg _ (notebook text embeddedMorphsIndexes detect: [:a |
		a value == promptMorph] ifNone: [^ nil]) key.

	iend _ (notebook text indexOf: notebook separator first 
		startingAt: ibeg ifAbsent: [^ nil]) -1.

	^ (notebook text copyFrom: ibeg + 1 to: iend -1) asString withBlanksTrimmed! !

!NotebookCell methodsFor: 'menu' stamp: 'spfa 12/11/2010 00:19'!
menu

	| m comment |

	m _ MenuMorph new defaultTarget: notebook; thenAction: #checkUpCells.

	m 
	add: 'evaluate' target: self selector: #evaluate.

	m
	addLine;
	add: {
		'passive' -> nil.
		'trigger' -> #trigger.
		'interactive' -> #interactive.
	} valuesForProperty: #status target: promptMorph.	
	
	m addLine;
	add: 'hide output' target: self action: #hideOutput;
	add: 'remove output' target: self action: #removeOutput ;
	add: 'insert cell' target: self action: #insertCell;	
	addLine;
	add: 'swap with ...' selector: #swap: argument: promptMorph;
	add: 'insert before ...' selector: #insert: argument: promptMorph;	
	add: 'with comments' toggleForProperty: #swapComments target: notebook;
	addLine.

	(comment _ self comment) ifNil:
		[
		(notebook hasProperty: #cutComment)
			ifTrue: [m add: 'paste comment' target: self action: #pasteComment].
		m add: 'add comment' target: self action: #prependComment]
		ifNotNil: [
			m add: 'select comment' target: comment action: #addHalo;
			add: 'copy comment' target: self action: #copyComment;
			add: 'cut comment' target: self action: #removeComment].

	m addLine;
	add: 'get button' target: self action: #getButton;
	addLine;
	add: 'delete' target: self action: #crop.

	^ m ! !

!Notebook methodsFor: 'contents' stamp: 'spfa 11/28/2010 20:56'!
morphWrapper

	^ Morph new
			extent: 3@3;
			color: Color transparent;
			layoutInset: 3;
			cellInset: 1;
			wrapCentering: #center;
			hResizing: #shrinkWrap;
			vResizing: #shrinkWrap;
			listDirection: #leftToRight;
			layoutPolicy: TableLayout new! !

!Notebook class methodsFor: 'instance creation' stamp: 'spfa 8/11/2010 22:20'!
new: aString contents: anArray

	| nb who |

	who _ thisContext sender method who.

	nb _ self newStandAlone. 
	anArray do: [:cell |
		cell isString ifTrue: [nb addCell: cell comment: nil status: nil].
		cell isArray ifTrue: [nb addCell: cell second comment: cell first 
					status: (cell size = 3 ifTrue: [cell third] ifFalse: [nil])]].

	nb scroller offset: 0@0.

	((who first ~= #unknown) and: 
		[(who first firstPrecodeCommentFor: who second) = 'rewritable']) ifTrue: [
			nb setProperty: #storage 
				toValue: (MessageSend receiver: who first theNonMetaClass 
							selector: who second)].

	nb checkUpCells.

	^ nb inSystemWindowLabelled: aString
	! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 11/18/2009 18:14'!
newComment: contents

	| tm comment w h |

 	tm _  TextMorph new. 
	tm backgroundColor: self commentColor.
	tm autoFit: true; margins: 5; contents: contents.
	tm getProperty: #notebookComment.

	comment _ String cr asText, tm asAnchoredText.

	w _ self width - 20.
	h _ (tm textStyle defaultFont approxWidthOfText: tm contents)
			* tm textStyle defaultFont height / (w + 1).

	tm wrapFlag: true.
	tm extent: w @ h asInteger.

	^ comment

! !

!REPLMorph class methodsFor: 'instance creation' stamp: 'spfa 11/12/2010 12:57'!
newStandAlone

	| nb pm |

	pm _ PluggableMemory for: (nb _ self new).
	nb evaluator: pm.

	^ nb
	! !

!NotebookCell methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:14'!
notebook: anObject
	notebook _ anObject! !

!REPLMorph class methodsFor: 'instance creation' stamp: 'spfa 11/18/2009 18:16'!
on: anObject

	^ self new evaluator: anObject! !

!Notebook class methodsFor: 'instance creation' stamp: 'spfa 4/8/2010 18:28'!
openNew

	self newStandAlone inSystemWindow openInWorld! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 11/18/2009 18:14'!
output

	end == notebook getMyText size
		ifTrue: [^ notebook getMyText copyFrom: endInput+1 to: end].

	^ notebook getMyText copyFrom: endInput+1 to: end-1! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 11/18/2009 18:14'!
output: aText

	^ self replaceFrom: endInput + 1 to: end with: aText! !

!REPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 11/18/2009 18:16'!
outputQueue

	| fresh |

	self queue isEmpty ifTrue: [^ self].

	fresh _ self freshInput. 

	self updateText: (Text streamContents: [:stream |
							stream nextPutAll: (myContents ifNil: ['']).
							self queue size timesRepeat: 
								[stream nextPutAll: self queue next]]).

	self refreshDisplay: fresh! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 11/18/2009 18:14'!
overwriteWith: aText

	^ self replaceFrom: start-1 to: end with: aText
! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 8/11/2010 14:56'!
pasteComment

	self prependComment: (notebook valueOfProperty: #cutComment)
! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 11/18/2009 18:14'!
plainOutput: aMorph

	| m |

	m _ Morph new
			extent: 3@3;
			color: Color transparent;
			layoutInset: 3;
			cellInset: 3;
			wrapCentering: #center;
			hResizing: #shrinkWrap;
			vResizing: #shrinkWrap;
			listDirection: #leftToRight;
			layoutPolicy: TableLayout new.

	m addMorph: aMorph.

	^ m asAnchoredText
! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/18/2009 18:16'!
pointedCommand

	| beg end text line prompt |

	text _ textMorph contents asString.
	end _ (text indexOf: Character cr startingAt: selectionInterval last ifAbsent: [text size + 1]) - 1.
	
	beg _ text lastIndexOf: Character cr startingAt: end ifAbsent: [0].
	line _ text asString copyFrom: beg + 1 to: end.
	prompt  _ self promptString.

	(line beginsWith: prompt) ifFalse: [^ nil].

	^ (line copyFrom: (line skipAnySubStr: {prompt} startingAt: 1) to: line size)
			withBlanksTrimmed! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 8/11/2010 22:10'!
prepend: aText

	| fullText  |

	fullText _ notebook getMyText.

	start < 3 ifTrue: 
		[notebook updateText: aText, fullText] 
	ifFalse: [ 
		notebook updateText: (fullText copyFrom: 1 to: start -2), 
			aText,
			(fullText copyFrom: start -1 to: fullText size)].

	notebook refreshDisplay: notebook prompt.! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 11/18/2009 18:14'!
prependComment

	self prependComment:  ' ... blah ... '! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 8/11/2010 22:12'!
prependComment: aText

	self prepend: (notebook newComment: aText)! !

!REPLTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:16'!
printIt
	"Treat the current text selection as an expression; evaluate it. Insert the 
	description of the result of evaluation after the selection and then make 
	this description the new text selection."
	| result |
	result _ self evaluateSelection.
	((result isKindOf: FakeClassPool) or: [result == #failedDoit])
			ifTrue: [view flash]
			ifFalse: [self afterSelectionInsertAndSelect: (result printString)]! !

!Notebook methodsFor: 'initialization' stamp: 'spfa 4/2/2010 11:14'!
prompt
	
	^ self prompt: nil! !

!REPLMorph methodsFor: 'initialization' stamp: 'spfa 11/18/2009 18:16'!
prompt
	
	^ (evaluator ifNil: [^ '> ']) prompt, ' '! !

!Notebook methodsFor: 'initialization' stamp: 'spfa 8/11/2010 14:46'!
prompt: aSymbol
	
	| m |

	m _ self buttonMorph
		target: self;
		actionSelector: #promptMenu:;
		label: super prompt asString withBlanksTrimmed.

	m getProperty: #notebookPrompt.
	m arguments: {m}.

	aSymbol ifNotNil: [m setProperty: #status toValue: aSymbol].

	^ m asAnchoredText, ' ' asText
! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 8/11/2010 14:49'!
promptMenu: aButtonMorph
	
	| cell |

	cell _ (NotebookCell at: aButtonMorph) ifNil: [^ self].

	(self hasProperty: #swap) ifTrue: [^ self swapWith: aButtonMorph].
	(self hasProperty: #insert) ifTrue: [^ self insertBefore: aButtonMorph].
	
	^ cell menu popUpInWorld
! !

!NotebookCell methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:15'!
promptMorph
	^promptMorph! !

!NotebookCell methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:15'!
promptMorph: anObject
	promptMorph _ anObject! !

!Notebook methodsFor: 'initialization' stamp: 'spfa 11/18/2009 18:14'!
promptString
	
	^ (Character value: 1) asString
! !

!REPLMorph methodsFor: 'initialization' stamp: 'spfa 11/18/2009 18:16'!
promptString

	^ self prompt asString withoutTrailingBlanks! !

!Notebook methodsFor: 'menu' stamp: 'spfa 4/3/2010 18:20'!
proposeLastAnswer

	^ false
! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 4/3/2010 18:20'!
proposeLastAnswer

	^ true
! !

!REPLMorph methodsFor: 'initialization' stamp: 'spfa 11/18/2009 18:16'!
queue

	^ queue ifNil: [queue _ SharedQueue new]! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 11/18/2009 18:15'!
refresh

	self input: (self liveInput ifNil: [^ self]).
	self anew evaluate! !

!Notebook methodsFor: 'contents' stamp: 'spfa 11/28/2010 22:07'!
refreshDisplay: aString

	| fullText |

	fullText _ myContents ifNil: [aString] 
		ifNotNil: [myContents, aString].

	geometriesCache _ IdentityDictionary new.

	fullText embeddedMorphs do: [:m |
		(m hasProperty: #notebookComment)
			ifTrue: [m extent: (self width - 20) @ m height.].
		geometriesCache add: m -> m extent].

	textMorph newContents: fullText.
	self selectFrom: fullText size + 1 to: fullText size + 1.
	self selectionInterval: (self text size + 1 to: self text size + 1)	

! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 11/18/2009 18:16'!
refreshDisplay: freshText

	| fullText |

	fullText _ myContents ifNil: [freshText] 
		ifNotNil: [myContents, freshText].
	textMorph newContents: fullText.
	self selectFrom: fullText size + 1 to: fullText size + 1.
	self scrollSelectionIntoView; setScrollDeltas; refreshWorld.
	

! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/18/2009 18:16'!
registerCommand: aString

	self commandsHistory remove: aString ifAbsent: [].
	commandsHistory addFirst: aString.
	commandsHistory size > self class historyLength
		 ifTrue: [commandsHistory removeLast].
! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 11/18/2009 18:14'!
removeAllOutput

	self cellsDo: [:cell | cell removeOutput]
! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 8/11/2010 14:59'!
removeComment

	| fullText  |

	fullText _ notebook getMyText.

	self copyComment.

	start < 4 ifTrue: [
		notebook updateText: (fullText copyFrom: start to: fullText size)] 
	ifFalse: [ 
		notebook updateText: (fullText copyFrom: 1 to: start -4), 
			(fullText copyFrom: start -1 to: fullText size)].

	notebook refreshDisplay: notebook prompt.! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 11/18/2009 18:15'!
removeOutput

	^ self output: String cr
! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 11/18/2009 18:15'!
replaceFrom: anIndex to: bIndex with: aText

	| emorphs fullText |

	fullText _ notebook getMyText.
	emorphs _ fullText embeddedMorphsFrom: anIndex to: bIndex. 

	notebook updateText: (bIndex = fullText size ifTrue: 
			[(fullText copyFrom: 1 to: anIndex), aText]
		ifFalse: [(fullText copyFrom: 1 to: anIndex), aText,
					(fullText copyFrom: bIndex to: fullText size)]).

	emorphs do: [:m | m delete].

	notebook refreshDisplay: notebook prompt! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 4/9/2010 00:57'!
resetCommandsHistory

	^ commandsHistory _ lastAnswer _ lastError _ lastValue _ nil
! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 11/18/2009 18:14'!
rewritedFromCells

	(Notebook new: self headerLabel
		contents: self contents) openInWorld
! !

!Notebook methodsFor: 'private' stamp: 'spfa 9/7/2010 20:35'!
scrollBar

	^ scrollBar! !

!REPLTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:16'!
selectionAsStream
	"Answer a ReadStream on the text in the paragraph that is currently 
	selected."

	^PositionableStream
		on: paragraph string
		from: self startIndex
		to: self stopIndex - 1! !

!REPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 11/18/2009 18:16'!
semaphore

	^ semaphore ifNil: [semaphore _ Semaphore forMutualExclusion]! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 11/18/2009 18:14'!
separator

	^ (Character value: 2) asText 
			addAttribute: (TextColor color: Color transparent) from: 1 to: 1! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 11/18/2009 18:16'!
setMyText: text

	| command  |

	(self hasProperty: #inCommand)
	ifTrue:
	[ | psize form |
		psize _ myContents size.
		(psize <= text size) ifTrue:
		[
			self updateText: 
				((text, String cr) 
					addAttributes: self class commandAttributes from: psize + 1 to: text size+1;
					addAttribute: self class displayFontAttribute from: psize + 1 to: text size+1).
			self refreshDisplay: ''.
			form _ text copyFrom: psize + 1 to: text size.
			self registerCommand: form asString.
			evaluator inputStream nextPutAll: form asString.
			evaluator inputStream skip: form size negated.
		].
		^ self 
	].

	(command _ self currentCommandFor: text) isEmpty 
	ifFalse: [ 
			self updateText: text, String cr.
			self refreshDisplay: ''.
	"		[self doCommand: command] fork."
			self doCommand: command
	]
	ifTrue: [self updateText: text ].

! !

!REPLMorph methodsFor: 'initialization' stamp: 'spfa 11/18/2009 18:16'!
setText: aText
	scrollBar setValue: 0.0.
	textMorph
		ifNil: [textMorph := REPLTextMorphForEditView new
						contents: aText wrappedTo: self innerBounds width-6.
				textMorph setEditView: self.
				scroller addMorph: textMorph]
		ifNotNil: [textMorph newContents: aText].
	self hasUnacceptedEdits: false.
	self setScrollDeltas.! !

!REPLPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:16'!
setText: aText
	scrollBar setValue: 0.0.
	textMorph
		ifNil: [textMorph := REPLTextMorphForEditView new
						contents: aText wrappedTo: self innerBounds width-6.
				textMorph setEditView: self.
				scroller addMorph: textMorph]
		ifNotNil: [textMorph newContents: aText].
	self hasUnacceptedEdits: false.
	self setScrollDeltas.! !

!REPLPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:16'!
spawn! !

!REPLTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:16'!
spawn

	! !

!NotebookCell methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:15'!
start

	^ start! !

!NotebookCell methodsFor: 'menu' stamp: 'spfa 8/12/2010 02:01'!
status

	^ promptMorph valueOfProperty: #status! !

!Notebook methodsFor: 'stepping' stamp: 'spfa 11/18/2009 18:14'!
step

	(self hasProperty: #refreshDisplay) ifTrue: [
		self removeProperty: #refreshDisplay.
		^ self refreshDisplay: self prompt].

	geometriesCache ifNil: [^ self].
	geometriesCache keysAndValuesDo: [:m :xt |
		m extent ~= xt ifTrue: [^ self refreshDisplay: self prompt]]! !

!REPLMorph methodsFor: 'stepping' stamp: 'spfa 11/18/2009 18:16'!
step

	self endEntry! !

!Notebook methodsFor: 'stepping' stamp: 'spfa 11/18/2009 18:14'!
stepTime

	^ 25! !

!REPLMorph methodsFor: 'stepping' stamp: 'spfa 11/18/2009 18:16'!
stepTime

	^ 200! !

!Notebook methodsFor: 'storage' stamp: 'spfa 5/23/2010 23:23'!
storeAsSelector: aSymbol in: aClass

	aClass compileNewSelectorNamed: aSymbol streamContents: [:str |
		str tab; nextPutAll: '"rewritable"'; cr.
		str tab; nextPutAll: '^ '.
		str nextPutAll: self constructor].

	self setProperty: #storage 
		toValue: (MessageSend receiver: aClass selector: aSymbol)


! !

!Notebook methodsFor: 'storage' stamp: 'spfa 11/18/2009 18:14'!
storeAsSelector: aSymbol in: aClass classifiedUnder: bSymbol

	self storeAsSelector: aSymbol in: aClass.
	aClass class organization classify: aSymbol under: bSymbol.
! !

!REPLMorph methodsFor: 'initialization' stamp: 'spfa 3/22/2010 11:24'!
storeDataOn: aDataStream

	debugContinuation := lastAnswer := lastError := lastValue :=  nil.
	super storeDataOn: aDataStream
! !

!Notebook methodsFor: 'storage' stamp: 'spfa 4/2/2010 11:10'!
stringContents

	^ self contents! !

!Notebook methodsFor: 'contents' stamp: 'spfa 3/24/2010 15:12'!
swap: aMorph

	aMorph setProperty: #passiveColor toValue: aMorph color.
	self setProperty: #swap toValue: aMorph.
	aMorph color: Color orange! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 8/11/2010 15:25'!
swapWith: aButtonMorph
	
	| cell promptMorph tempText first second fc sc |

	cell _ NotebookCell at: aButtonMorph.
	promptMorph _ self valueOfProperty: #swap.
	self removeProperty: #swap.
	promptMorph color: (promptMorph valueOfProperty: #passiveColor).

	promptMorph == aButtonMorph ifTrue: [^ self].

	first _ (NotebookCell at: promptMorph).
	(second _ cell) start < first start 
		ifTrue: [second _ first . first _ cell].
		
	(self hasProperty: #swapComments) ifTrue: [	
		fc _ (NotebookCell at: promptMorph) comment.
		sc _ (NotebookCell at: aButtonMorph) comment].
	
	tempText _ second contents.
	second overwriteWith: first contents.
	first overwriteWith: tempText.
	
	(self hasProperty: #swapComments) ifTrue: [		
		sc ifNotNil: [(NotebookCell at: promptMorph) removeComment].
		fc ifNotNil: [(NotebookCell at: aButtonMorph) removeComment].		
		sc ifNotNil: [(NotebookCell at: aButtonMorph) prependComment: sc contents].	
		fc ifNotNil: [(NotebookCell at: promptMorph) prependComment: fc contents]].			

	
	! !

!REPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 11/18/2009 18:16'!
update: aSymbol 

	aSymbol ifNil: [^self].

	aSymbol == #endEntry 
		ifTrue: 
			[self endEntry].

	aSymbol == #appendEntry 
		ifTrue: 
			[self appendEntry].
	aSymbol == #clearText 
		ifTrue: 
			[self clear].
	aSymbol == #force 
		ifTrue: 
			[self outputQueue].! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 11/18/2009 18:16'!
updateText: text

	| ttext |

	ttext _ text size > self characterLimit 
		ifTrue: [text copyFrom: text size - self characterLimit to: text size]
		ifFalse: [text].

	super setMyText: ttext.
! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/18/2009 18:16'!
wantsDroppedMorph: aMorph event: evt

	^ aMorph hasProperty: #replCommands
	
	! !

!REPLMorph methodsFor: 'initialization' stamp: 'spfa 11/18/2009 18:16'!
wantsFrameAdornments

	^ false! !

!Notebook methodsFor: 'stepping' stamp: 'spfa 11/18/2009 18:14'!
wantsSteps

	^ true! !

!REPLMorph methodsFor: 'stepping' stamp: 'spfa 11/18/2009 18:16'!
wantsSteps

	^ true! !

!Notebook class methodsFor: 'instance creation' stamp: 'spfa 11/18/2009 18:14'!
windowColor

	^ Color greenYellow darker! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 8/14/2010 23:04'!
wrapForOutput: anObject

	anObject isSymbol ifTrue: [^ anObject storeString].

	^ anObject asString asText
! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 11/7/2010 19:30'!
wrapMorphForOutput: aMorph

	| m controls hbutt hh |

	m _ self morphWrapper.

	controls _ self controlsWrapper listDirection: #topToBottom.

	m addMorph: controls.
	m addMorph: aMorph.

	hbutt _ self buttonMorph label: 'show'; target: m; actionSelector: #become:.
	hbutt arguments: {hbutt}.

	hh _ self controlsWrapper.
	controls addMorph: hh.
	hh addMorph: (self buttonMorph label: 'hide';
								 target: m; actionSelector: #become:;
								 arguments: {hbutt}).

	hh addMorph: (self buttonMorph label: 'halo';
								actWhen: #buttonUp;
								 target: aMorph; actionSelector: #addHalo).

	self addControlButtonsTo: controls for: aMorph.

	^ m asAnchoredText
! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/18/2009 18:16'!
yellowButtonActivity

	(self getMenu: false) invokeModal! !

!REPLPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:16'!
yellowButtonActivity

	(self getMenu: false) invokeModal! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/18/2009 18:16'!
yellowButtonActivity: shiftKeyState

	(self getMenu: shiftKeyState) invokeModal! !

!REPLPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:16'!
yellowButtonActivity: shiftKeyState

	(self getMenu: shiftKeyState) invokeModal! !
